<?php

namespace Teknisa\SM\Service;
use Teknisa\SM\Factory\Sm00015000ApropriacaoRecursosFactory;

class Sm00015000ApropriacaoRecursosService
{
    protected $apropriacaoFactory;

    public function __construct (Sm00015000ApropriacaoRecursosFactory $apropriacaoFactory) {
        $this->apropriacaoFactory = $apropriacaoFactory;
    }
    /**
     * Atualizando no banco o campo da tabela de apropriação com as
     * horas que foram excluidas ou adicionadas
     */
    public function atualizarQtdHorasApropriadas($nrapropagendamento,$nrorg){

         $params = array(
            "NRAPROPAGENDAMENTO" => $nrapropagendamento,
            "NRORG"         => $nrorg
            );
        
         $this->apropriacaoFactory->atualizarQtdHorasApropriadas($params);
       
    }
    /**
     * Retorna as horas apropriada para atuliza na tela
     */
    public function getQtdHorasApropriadas($nrapropagendamento,$nrorg){

         $params = array(
            "NRAPROPAGENDAMENTO" => $nrapropagendamento,
            "NRORG"         => $nrorg
            );
        
         $dados = $this->apropriacaoFactory->getQtdHorasApropriadas($params);
         return $dados[0];
       
    }
    /**
     * Atualizando no banco o campo da tabela de apropriação com as
     * horas que foram excluidas ou adicionadas
     */
    public function atualizarSituacaoDoRecurso($nrapropagendamento,$nrorg){

         $params = array(
            "NRAPROPAGENDAMENTO" => $nrapropagendamento,
            "NRORG"         => $nrorg
            );
        
         $this->apropriacaoFactory->atualizarSituacaoDoRecurso($params);
       
    }
    /**
     * Retorna as horas apropriada para atuliza na tela
     */
    public function getSituacaoDoApontamento($nrapropagendamento,$nrorg){

         $params = array(
            "NRAPROPAGENDAMENTO" => $nrapropagendamento,
            "NRORG"         => $nrorg
            );
        
         $dados = $this->apropriacaoFactory->getSituacaoDoApontamento($params);
         return $dados[0];
       
    }
}

?>