/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_IMUN                                                     */
/* Tabela : INSCRMUNICIP                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_IMUN
BEFORE INSERT OR UPDATE OR DELETE
ON INSCRMUNICIP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUIMUN := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDINSCMUNI,0) <> NVL(:NEW.CDINSCMUNI,0)) OR
         (NVL(:OLD.CDEMPRESA,0)  <> NVL(:NEW.CDEMPRESA,0))  OR
         (NVL(:OLD.NRCERTDIGNFSE,0)  <> NVL(:NEW.NRCERTDIGNFSE,0)) OR
         (NVL(:OLD.IDAMBTRABNFSE,0)  <> NVL(:NEW.IDAMBTRABNFSE,0))  THEN
         :NEW.DTULTATUIMUN := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('INSCRMUNICIP', '', 'CDEMPRESA='||:OLD.CDEMPRESA||';CDINSCMUNI='||:OLD.CDINSCMUNI||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE INSCRMUNICIP MODIFY DTULTATUIMUN DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_IMUN','5.30.xxx'); END;
/

