/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_GRUPNUTR                                           			      */
/* Tabela : GRUPNUTR                                                           		 	      */
/*                                                                   					      */
/* Criao:                                                              				      */
/* 06/12/2004 - Rafael dos Santos Lopes                           				      */
/*                                                                      					      */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_GRUPNUTR
BEFORE INSERT OR UPDATE OR DELETE
ON GRUPNUTR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUGRNU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMGRUPNUTR,0) <> NVL(:NEW.NMGRUPNUTR,0)) THEN
         :NEW.DTULTATUGRNU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('GRUPNUTR', '', 'CDGRUPNUTR='||:OLD.CDGRUPNUTR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE GRUPNUTR MODIFY DTULTATUGRNU DEFAULT SYSDATE
/

