IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'GERA_NOTAFISCAL_DADOSADIC' AND
                 TYPE = 'P' 			         AND
                 U.UID = O.UID             	AND
                 U.NAME = USER)
DROP PROCEDURE GERA_NOTAFISCAL_DADOSADIC
GO
CREATE PROCEDURE GERA_NOTAFISCAL_DADOSADIC (@P_CDFILIAL    VARCHAR(4),
                                            @P_NRLANCTONF  VARCHAR(10),
                                            @P_DTINICIO    DATETIME,
                                            @P_DTFINAL     DATETIME,
                                            @P_MENSAGEM    VARCHAR(255) = NULL) AS
DECLARE @V_NRDADOADIC   VARCHAR(3);
DECLARE @V_MENSAGEM     VARCHAR(255);
DECLARE @V_IDORIGDESTNF VARCHAR(1);
DECLARE @V_CDCLIENTE    VARCHAR(21);
DECLARE @V_IDENTRSAIDOP VARCHAR(1);

/*VARIVEIS DO CURSOR C_MENSCLIENTE*/
DECLARE @V_MENSCLIENTE_CDMENSAGEM VARCHAR(03);
DECLARE @V_MENSCLIENTE_DSMENSCLIENTE VARCHAR(250);

DECLARE @V_DSENDEDEVOEMBA VARCHAR(255);
BEGIN
   --BUSCA MAIOR NRDADOADIC PARA INSERIR O PROXIMO
   SELECT @V_NRDADOADIC = ISNULL(MAX(NRDADOADIC),0)
     FROM DADOSADIC 
    WHERE CDFILIAL   = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF;
   
   SET @V_NRDADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRDADOADIC) + 1)),3);
   
   IF ((@P_MENSAGEM = '') OR (@P_MENSAGEM IS NULL)) BEGIN
      SET @V_MENSAGEM = 'PERODO DE APURAO '+ CONVERT(VARCHAR,@P_DTINICIO) + ' A ' + CONVERT(VARCHAR,@P_DTFINAL);
   END ELSE BEGIN
      SET @V_MENSAGEM = @P_MENSAGEM;
   END;

   INSERT INTO DADOSADIC (CDFILIAL,NRLANCTONF,NRDADOADIC,DSDADOADIC)
        VALUES (@P_CDFILIAL, @P_NRLANCTONF, @V_NRDADOADIC, @V_MENSAGEM);  

   SET @V_NRDADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRDADOADIC) + 1)),3);

   SELECT @V_IDORIGDESTNF = IDORIGDESTNF, 
          @V_CDCLIENTE = CDCLIENTE, 
          @V_IDENTRSAIDOP = CASE IDENTRSAIDOP WHEN 'S' THEN 'E' ELSE CASE IDENTRSAIDOP WHEN 'E' THEN 'S' ELSE IDENTRSAIDOP END END 
     FROM NOTAFISCAL
    WHERE CDFILIAL = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF;
   
   IF @V_IDORIGDESTNF = 'C' BEGIN
      DECLARE C_MENSCLIENTE CURSOR FOR SELECT M.CDMENSAGEM, C.DSMENSCLIENTE
                                         FROM MENSCLIENTE C LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = C.CDMENSAGEM)
                                        WHERE C.CDCLIENTE = @V_CDCLIENTE
                                          AND C.IDENTRSAIDMENS <> @V_IDENTRSAIDOP
                                          AND (((C.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (C.CDMENSAGEM IS NULL))
                                          AND NOT EXISTS (SELECT DSDADOADIC
                                                            FROM DADOSADIC
                                                           WHERE (CDFILIAL = @P_CDFILIAL)
                                                             AND (NRLANCTONF = @P_NRLANCTONF)
                                                             AND (DSDADOADIC LIKE C.DSMENSCLIENTE + '%'))
                                     ORDER BY C.NRMENSCLIENTE;
      OPEN C_MENSCLIENTE;
      FETCH NEXT FROM C_MENSCLIENTE INTO @V_MENSCLIENTE_CDMENSAGEM, 
                                         @V_MENSCLIENTE_DSMENSCLIENTE;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         INSERT INTO DADOSADIC
            (CDFILIAL, 
             NRLANCTONF, 
             NRDADOADIC, 
             CDMENSAGEM, 
             DSDADOADIC)
          VALUES
             (@P_CDFILIAL, 
              @P_NRLANCTONF, 
              @V_NRDADOADIC, 
              @V_MENSCLIENTE_CDMENSAGEM, 
              @V_MENSCLIENTE_DSMENSCLIENTE);

         SET @V_NRDADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRDADOADIC) + 1)),3);

         FETCH NEXT FROM C_MENSCLIENTE INTO @V_MENSCLIENTE_CDMENSAGEM, 
                                            @V_MENSCLIENTE_DSMENSCLIENTE;
      END;
      CLOSE C_MENSCLIENTE;
      DEALLOCATE C_MENSCLIENTE;
   END;
   SELECT V_DSENDEDEVOEMBA = TEKNISA.TRANSLATE(SUBSTRING('Devolver as embalagens vazias no seguinte endereo: ' + 
                             PRE.DSPOSTORECEMB +
                             ', ' + PRE.DSENDERECEMB +
                             CASE ISNULL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' + PRE.DSCOMPENDERECEMB END +
                             ', ' + B.NMBAIRRO +
                             ', CEP:' + PRE.NRCEPRECEMB +
                             ', ' + M.NMMUNICIPIO +
                             ', ' + E.SGESTADO +
                             ', ' + P.NMPAIS +
                             CASE ISNULL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' + PRE.NRTELERECEMB END +
                             CASE ISNULL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' + PRE.NRFAXRECEMB END, 1, 255), NULL, NULL)
     FROM NOTAFISCAL N JOIN ITEMPRODUTO I ON (N.CDFILIAL = I.CDFILIAL) AND
                                             (N.NRLANCTONF = I.NRLANCTONF)
                       JOIN PRODUTO PR ON (I.CDPRODUTO = PR.CDPRODUTO)
                       JOIN (SELECT P.CDPOSTORECEMB, PR.CDARVPROD
                               FROM PRODPOSTORECEMB P JOIN PRODUTO PR ON (P.CDPRODUTO = PR.CDPRODUTO)) PPRE ON (CHARINDEX(ISNULL(RTRIM(PPRE.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1)
                       JOIN CLIEPOSTORECEMB C ON (N.CDCLIENTE = C.CDCLIENTE) AND
                                                 (PPRE.CDPOSTORECEMB = C.CDPOSTORECEMB)
                       JOIN POSTORECEMB PRE ON (C.CDPOSTORECEMB = PRE.CDPOSTORECEMB)
                       JOIN PAIS P ON (PRE.CDPAIS = P.CDPAIS)
                       JOIN ESTADO E ON (PRE.CDPAIS = E.CDPAIS) AND
                                        (PRE.SGESTADO = E.SGESTADO)
                       JOIN MUNICIPIO M ON (PRE.CDPAIS = M.CDPAIS) AND
                                           (PRE.SGESTADO = M.SGESTADO) AND
                                           (PRE.CDMUNICIPIO = M.CDMUNICIPIO)
                       JOIN BAIRRO B ON (PRE.CDPAIS = B.CDPAIS) AND
                                        (PRE.SGESTADO = B.SGESTADO) AND
                                        (PRE.CDMUNICIPIO = B.CDMUNICIPIO) AND
                                        (PRE.CDBAIRRO = B.CDBAIRRO)
    WHERE N.CDFILIAL = @P_CDFILIAL
      AND N.NRLANCTONF = @P_NRLANCTONF
      AND NOT EXISTS (SELECT DSDADOADIC
                        FROM DADOSADIC
                       WHERE (CDFILIAL = @P_CDFILIAL)
                         AND (NRLANCTONF = @P_NRLANCTONF)
                         AND (DSDADOADIC LIKE TEKNISA.TRANSLATE(SUBSTRING('Devolver as embalagens vazias no seguinte endereo: ' +
                                              PRE.DSPOSTORECEMB +
                                              ', ' + PRE.DSENDERECEMB +
                                              CASE ISNULL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' + PRE.DSCOMPENDERECEMB END +
                                              ', ' + B.NMBAIRRO +
                                              ', CEP:' + PRE.NRCEPRECEMB +
                                              ', ' + M.NMMUNICIPIO +
                                              ', ' + E.SGESTADO +
                                              ', ' + P.NMPAIS +
                                              CASE ISNULL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' + PRE.NRTELERECEMB END +
                                              CASE ISNULL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' + PRE.NRFAXRECEMB END, 1, 255), NULL, NULL) + '%'));
     
   IF (@V_DSENDEDEVOEMBA IS NOT NULL) BEGIN
      INSERT INTO DADOSADIC
         (CDFILIAL, 
          NRLANCTONF, 
          NRDADOADIC, 
          CDMENSAGEM, 
          DSDADOADIC)
      VALUES
         (@P_CDFILIAL, 
          @P_NRLANCTONF, 
          @V_NRDADOADIC, 
          '',
          @V_DSENDEDEVOEMBA);

      SET @V_NRDADOADIC = RIGHT(REPLICATE('0',3) + RTRIM(CONVERT(VARCHAR, CONVERT(NUMERIC, @V_NRDADOADIC) + 1)),3);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_NOTAFISCAL_DADOSADIC','5.60.xxx';
GO